2 ############################################################################
4 # This file is part of the IPFire Firewall. #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
20 # Copyright (C) 2007-2018 IPFire Team <info@ipfire.org>. #
22 ############################################################################
25 NAME
="IPFire" # Software name
26 SNAME
="ipfire" # Short name
27 VERSION
="2.21" # Version number
28 CORE
="124" # Core Level (Filename)
29 PAKFIRE_CORE
="123" # Core Level (PAKFIRE)
30 GIT_BRANCH
=`git rev-parse --abbrev-ref HEAD` # Git Branch
31 SLOGAN
="www.ipfire.org" # Software slogan
32 CONFIG_ROOT
=/var
/ipfire
# Configuration rootdir
34 MAX_RETRIES
=1 # prefetch/check loop
35 BUILD_IMAGES
=1 # Flash and Xen Downloader
36 KVER
=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
37 GIT_TAG
=$
(git tag |
tail -1) # Git Tag
38 GIT_LASTCOMMIT
=$
(git log |
head -n1 | cut
-d" " -f2 |
head -c8) # Last commit
42 ###############################################################################
44 # Beautifying variables & presentation & input output interface
46 ###############################################################################
48 # Remember if the shell is interactive or not
49 if [ -t 0 ] && [ -t 1 ]; then
55 # Sets or adjusts pretty formatting variables
58 # Find current screen size
61 # When using remote connections, such as a serial port, stty size returns 0
62 if ! ${INTERACTIVE} ||
[ "${COLUMNS}" = "0" ]; then
66 # Measurements for positioning result messages
70 NAME_WIDTH
=$
(( COLUMNS
- OPTIONS_WIDTH
- TIME_WIDTH
- STATUS_WIDTH
))
71 LINE_WIDTH
=$
(( COLUMNS
- STATUS_WIDTH
))
73 TIME_COL
=$
(( NAME_WIDTH
+ OPTIONS_WIDTH
))
74 STATUS_COL
=$
(( TIME_COL
+ TIME_WIDTH
))
77 # Initially setup terminal
80 # Call resize_terminal when terminal is being resized
81 trap "resize_terminal" WINCH
83 # Define color for messages
91 # New architecture variables
92 HOST_ARCH
="$(uname -m)"
95 BASENAME
=$
(basename $0)
97 # Debian specific settings
98 if [ ! -e /etc
/debian_version
]; then
101 if [ -x /usr
/bin
/realpath
]; then
102 FULLPATH
=`/usr/bin/realpath $0`
104 echo "ERROR: Need to do apt-get install realpath"
109 # This is the directory where make.sh is in
110 export BASEDIR
=$
(echo $FULLPATH |
sed "s/\/$BASENAME//g")
112 LOGFILE
=$BASEDIR/log
/_build.preparation.log
114 DIR_CHK
=$BASEDIR/cache
/check
115 mkdir
$BASEDIR/log
/ 2>/dev
/null
117 system_processors
() {
118 getconf _NPROCESSORS_ONLN
2>/dev
/null ||
echo "1"
124 while read -r key val unit
; do
128 echo "$(( ${val} / 1024 ))"
136 local build_arch
="${1}"
138 if [ "${build_arch}" = "default" ]; then
139 build_arch
="$(configure_build_guess)"
142 case "${build_arch}" in
144 BUILDTARGET
="${build_arch}-unknown-linux-gnu"
145 CROSSTARGET
="${build_arch}-cross-linux-gnu"
147 CFLAGS_ARCH
="-m64 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic"
151 BUILDTARGET
="${build_arch}-pc-linux-gnu"
152 CROSSTARGET
="${build_arch}-cross-linux-gnu"
154 CFLAGS_ARCH
="-march=i586 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic -fomit-frame-pointer"
158 BUILDTARGET
="${build_arch}-unknown-linux-gnu"
159 CROSSTARGET
="${build_arch}-cross-linux-gnu"
165 BUILDTARGET
="${build_arch}-unknown-linux-gnueabi"
166 CROSSTARGET
="${build_arch}-cross-linux-gnueabi"
168 CFLAGS_ARCH
="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
172 BUILDTARGET
="${build_arch}-unknown-linux-gnueabi"
173 CROSSTARGET
="${build_arch}-cross-linux-gnueabi"
175 CFLAGS_ARCH
="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
179 exiterror
"Cannot build for architure ${build_arch}"
183 # Check if the QEMU helper is available if needed.
184 if qemu_is_required
"${build_arch}"; then
185 local qemu_build_helper
="$(qemu_find_build_helper_name "${build_arch}")"
187 if [ -n "${qemu_build_helper}" ]; then
188 QEMU_TARGET_HELPER
="${qemu_build_helper}"
190 exiterror
"Could not find a binfmt_misc helper entry for ${build_arch}"
194 BUILD_ARCH
="${build_arch}"
195 TOOLS_DIR
="/tools_${BUILD_ARCH}"
198 HARDENING_CFLAGS
="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
200 CFLAGS
="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
203 # Determine parallelism
204 if [ -z "${MAKETUNING}" ]; then
205 # We assume that each process consumes about
206 # 192MB of memory. Therefore we find out how
207 # many processes fit into memory.
208 local mem_max
=$
(( ${HOST_MEM} / 192 ))
210 local processors
="$(system_processors)"
211 local cpu_max
=$
(( ${processors} + 1 ))
214 if [ ${mem_max} -lt ${cpu_max} ]; then
215 parallelism
=${mem_max}
217 parallelism
=${cpu_max}
220 # limit to -j23 because perl will not build
222 if [ ${parallelism} -gt 23 ]; then
226 MAKETUNING
="-j${parallelism}"
229 # Compression parameters
230 # We use mode 8 for reasonable memory usage when decompressing
231 # but with overall good compression
234 # We try to use as many cores as possible
235 XZ_OPT
="${XZ_OPT} -T0"
237 # We need to limit memory because XZ uses too much when running
238 # in parallel and it isn't very smart in limiting itself.
239 # We allow XZ to use up to 70% of all system memory.
240 local xz_memory
=$
(( HOST_MEM
* 7 / 10 ))
242 # XZ memory cannot be larger than 2GB on 32 bit systems
243 case "${build_arch}" in
245 if [ ${xz_memory} -gt 2048 ]; then
251 XZ_OPT
="${XZ_OPT} --memory=${xz_memory}MiB"
254 configure_build_guess
() {
255 case "${HOST_ARCH}" in
264 armv7
*|armv6
*|armv5
*)
269 exiterror
"Cannot guess build architecture"
275 umount
$BASEDIR/build
/sys
2>/dev
/null
;
276 umount
$BASEDIR/build
/dev
/shm
2>/dev
/null
;
277 umount
$BASEDIR/build
/dev
/pts
2>/dev
/null
;
278 umount
$BASEDIR/build
/dev
2>/dev
/null
;
279 umount
$BASEDIR/build
/proc
2>/dev
/null
;
280 umount
$BASEDIR/build
/install
/mnt
2>/dev
/null
;
281 umount
$BASEDIR/build
/usr
/src
/cache
2>/dev
/null
;
282 umount
$BASEDIR/build
/usr
/src
/ccache
2>/dev
/null
;
283 umount
$BASEDIR/build
/usr
/src
/config
2>/dev
/null
;
284 umount
$BASEDIR/build
/usr
/src
/doc
2>/dev
/null
;
285 umount
$BASEDIR/build
/usr
/src
/html
2>/dev
/null
;
286 umount
$BASEDIR/build
/usr
/src
/langs
2>/dev
/null
;
287 umount
$BASEDIR/build
/usr
/src
/lfs
2>/dev
/null
;
288 umount
$BASEDIR/build
/usr
/src
/log
2>/dev
/null
;
289 umount
$BASEDIR/build
/usr
/src
/src
2>/dev
/null
;
299 if [ ${seconds} -ge 3600 ]; then
300 printf "%d:%02d:%02d\n" \
301 "$(( seconds / 3600 ))" \
302 "$(( seconds % 3600 / 60 ))" \
303 "$(( seconds % 3600 % 60 ))"
304 elif [ ${seconds} -ge 60 ]; then
306 "$(( seconds / 60 ))" \
307 "$(( seconds % 60 ))"
309 printf "%d\n" "${seconds}"
316 printf "%-${LINE_WIDTH}s" "${line}"
323 if ${INTERACTIVE}; then
329 if ${INTERACTIVE}; then
335 _print_line BOLD
"$@"
339 _print_line FAIL
"$@"
346 local version
="$(grep -E "^VER |^VER
=|^VER
" $BASEDIR/lfs/${name} | awk '{ print $3 }')"
349 local string
="${name}"
350 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
351 string
="${string} (${version})"
354 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
355 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
359 local runtime
=$
(format_runtime $@
)
361 if ${INTERACTIVE}; then
362 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
364 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
371 local color
="${!status}"
373 if ${INTERACTIVE}; then
374 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
376 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
380 print_build_stage
() {
387 print_build_summary
() {
388 local runtime
=$
(format_runtime $@
)
390 print_line
"*** Build finished in ${runtime}"
396 for i
in `seq 0 7`; do
397 if ( losetup
/dev
/loop
${i} 2>/dev
/null |
grep -q "/install/images" ); then
398 losetup
-d /dev
/loop
${i} 2>/dev
/null
403 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
407 while read -r line
; do
409 done <<< "$(tail -n30 ${LOGFILE})"
415 for line
in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
416 print_error
"${line}"
424 # Are we running the right shell?
425 if [ -z "${BASH}" ]; then
426 exiterror
"BASH environment variable is not set. You're probably running the wrong shell."
429 if [ -z "${BASH_VERSION}" ]; then
430 exiterror
"Not running BASH shell."
433 # Trap on emergency exit
434 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
436 # Resetting our nice level
437 if ! renice
${NICE} $$
>/dev
/null
; then
438 exiterror
"Failed to set nice level to ${NICE}"
441 # Checking if running as root user
442 if [ $
(id
-u) -ne 0 ]; then
443 exiterror
"root privileges required for building"
446 # Checking for necessary temporary space
447 print_line
"Checking for necessary space on disk $BASE_DEV"
448 BASE_DEV
=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
449 BASE_ASPACE
=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
450 if (( 2048000 > $BASE_ASPACE )); then
451 BASE_USPACE
=`du -skx $BASEDIR | awk '{print $1}'`
452 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
454 exiterror
"Not enough temporary space available, need at least 2GB on $BASE_DEV"
469 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
470 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
472 # Make some extra directories
473 mkdir
-p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev
/null
474 mkdir
-p $BASEDIR/build
/{etc
,usr
/src
} 2>/dev
/null
475 mkdir
-p $BASEDIR/build
/{dev
/{shm
,pts
},proc
,sys
}
476 mkdir
-p $BASEDIR/{cache
,ccache
} 2>/dev
/null
477 mkdir
-p $BASEDIR/build
/usr
/src
/{cache
,config
,doc
,html
,langs
,lfs
,log
,src
,ccache
}
479 mknod
-m 600 $BASEDIR/build
/dev
/console c
5 1 2>/dev
/null
480 mknod
-m 666 $BASEDIR/build
/dev
/null c
1 3 2>/dev
/null
482 # Make all sources and proc available under lfs build
483 mount
--bind /dev
$BASEDIR/build
/dev
484 mount
--bind /dev
/pts
$BASEDIR/build
/dev
/pts
485 mount
--bind /dev
/shm
$BASEDIR/build
/dev
/shm
486 mount
--bind /proc
$BASEDIR/build
/proc
487 mount
--bind /sys
$BASEDIR/build
/sys
488 mount
--bind $BASEDIR/cache
$BASEDIR/build
/usr
/src
/cache
489 mount
--bind $BASEDIR/ccache
$BASEDIR/build
/usr
/src
/ccache
490 mount
--bind $BASEDIR/config
$BASEDIR/build
/usr
/src
/config
491 mount
--bind $BASEDIR/doc
$BASEDIR/build
/usr
/src
/doc
492 mount
--bind $BASEDIR/html
$BASEDIR/build
/usr
/src
/html
493 mount
--bind $BASEDIR/langs
$BASEDIR/build
/usr
/src
/langs
494 mount
--bind $BASEDIR/lfs
$BASEDIR/build
/usr
/src
/lfs
495 mount
--bind $BASEDIR/log
$BASEDIR/build
/usr
/src
/log
496 mount
--bind $BASEDIR/src
$BASEDIR/build
/usr
/src
/src
498 # Run LFS static binary creation scripts one by one
499 export CCACHE_DIR
=$BASEDIR/ccache
500 export CCACHE_COMPRESS
=1
501 export CCACHE_COMPILERCHECK
="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
503 # Remove pre-install list of installed files in case user erase some files before rebuild
504 rm -f $BASEDIR/build
/usr
/src
/lsalr
2>/dev
/null
506 # Prepare string for /etc/system-release.
507 SYSTEM_RELEASE
="${NAME} ${VERSION} (${BUILD_ARCH})"
508 if [ "$(git status -s | wc -l)" == "0" ]; then
513 case "$GIT_BRANCH" in
515 SYSTEM_RELEASE
="${SYSTEM_RELEASE} - $GIT_BRANCH$GIT_STATUS"
518 SYSTEM_RELEASE
="${SYSTEM_RELEASE} - Development Build: $GIT_BRANCH/$GIT_LASTCOMMIT$GIT_STATUS"
524 # Install QEMU helper, if needed
527 local PATH
="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
529 PATH
="${PATH}" chroot
${LFS} env
-i \
534 SYSTEM_RELEASE
="${SYSTEM_RELEASE}" \
535 PAKFIRE_CORE
="${PAKFIRE_CORE}" \
538 VERSION
="${VERSION}" \
541 TOOLS_DIR
="${TOOLS_DIR}" \
542 CONFIG_ROOT
="${CONFIG_ROOT}" \
543 CFLAGS
="${CFLAGS} ${HARDENING_CFLAGS}" \
544 CXXFLAGS
="${CXXFLAGS} ${HARDENING_CFLAGS}" \
545 BUILDTARGET
="${BUILDTARGET}" \
546 CROSSTARGET
="${CROSSTARGET}" \
547 BUILD_ARCH
="${BUILD_ARCH}" \
548 BUILD_PLATFORM
="${BUILD_PLATFORM}" \
549 CCACHE_DIR
=/usr
/src
/ccache \
550 CCACHE_COMPRESS
="${CCACHE_COMPRESS}" \
551 CCACHE_COMPILERCHECK
="${CCACHE_COMPILERCHECK}" \
560 if [ ! -e $BASEDIR/build
/usr
/src
/lfs
/ ]; then
561 exiterror
"No such file or directory: $BASEDIR/build/usr/src/lfs/"
564 echo "Entering to a shell inside LFS chroot, go out with exit"
565 local PS1
="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
567 if enterchroot bash
-i; then
571 exiterror
"chroot error"
575 lfsmakecommoncheck
() {
577 if [ ! -f $BASEDIR/lfs
/$1 ]; then
578 exiterror
"No such file or directory: $BASEDIR/$1"
581 # Print package name and version
584 # Check if this package is supported by our architecture.
585 # If no SUP_ARCH is found, we assume the package can be built for all.
586 if grep "^SUP_ARCH" ${BASEDIR}/lfs
/${1} >/dev
/null
; then
587 # Check if package supports ${BUILD_ARCH} or all architectures.
588 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
597 for i in $SKIP_PACKAGE_LIST
599 if [ "$i" == "$1" ]; then
605 echo -ne "`date -u '+%b %e %T'`: Building $
* " >> $LOGFILE
607 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
608 MESSAGE="$1\t " download >> $LOGFILE 2>&1
609 if [ $? -ne 0 ]; then
610 exiterror "Download error
in $1"
613 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
614 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
615 if [ $? -ne 0 ]; then
616 exiterror "md5sum error
in $1, check
file in cache or signature
"
623 lfsmakecommoncheck $*
624 [ $? == 1 ] && return 0
626 cd $BASEDIR/lfs && env -i \
627 PATH="${TOOLS_DIR}/ccache
/bin
:${TOOLS_DIR}/bin
:$PATH" \
628 CCACHE_DIR="${CCACHE_DIR}" \
629 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
630 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
632 CXXFLAGS="${CXXFLAGS}" \
633 MAKETUNING="${MAKETUNING}" \
636 TOOLS_DIR="${TOOLS_DIR}" \
637 CROSSTARGET="${CROSSTARGET}" \
638 BUILDTARGET="${BUILDTARGET}" \
639 BUILD_ARCH="${BUILD_ARCH}" \
640 BUILD_PLATFORM="${BUILD_PLATFORM}" \
641 LFS_BASEDIR="${BASEDIR}" \
644 install >> $LOGFILE 2>&1 &
646 if ! wait_until_finished $!; then
648 exiterror "Building $
*"
655 lfsmakecommoncheck $*
656 [ $? == 1 ] && return 0
661 ${EXTRA_PATH}bash -x -c "cd /usr
/src
/lfs
&& \
662 MAKETUNING
=${MAKETUNING} \
664 LFS_BASEDIR
=/usr
/src
install" \
667 if ! wait_until_finished $!; then
669 exiterror "Building $
*"
676 lfsmakecommoncheck $*
677 [ $? == 1 ] && return 0
682 bash -x -c "cd /usr
/src
/lfs
&& make -f $
* LFS_BASEDIR
=/usr
/src dist
" \
685 if ! wait_until_finished $!; then
687 exiterror "Packaging $
*"
693 wait_until_finished() {
696 local start_time=$(now)
699 if ${INTERACTIVE}; then
700 # Wait a little just in case the process
701 # has finished very quickly.
705 while kill -0 ${pid} 2>/dev/null; do
706 print_runtime $(( $(now) - ${start_time} ))
713 # Returns the exit code of the child process
717 if ! ${INTERACTIVE}; then
718 print_runtime $(( $(now) - ${start_time} ))
725 [ -e "${BASEDIR}/build
${TOOLS_DIR}/lib
/libpakfire_preload.so
" ] || return
727 local env="LD_PRELOAD
=${TOOLS_DIR}/lib
/libpakfire_preload.so
"
729 # Fake kernel version, because some of the packages do not compile
730 # with kernel 3.0 and later.
731 env="${env} UTS_RELEASE
=${KVER}"
733 # Fake machine version.
734 env="${env} UTS_MACHINE
=${BUILD_ARCH}"
742 # Don't add anything if qemu is not used.
743 if ! qemu_is_required; then
747 # Set default qemu options
748 case "${BUILD_ARCH}" in
750 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
752 env="${env} QEMU_CPU
=${QEMU_CPU}"
757 #env="${env} QEMU_STRACE
=1"
763 local build_arch="${1}"
765 if [ -z "${build_arch}" ]; then
766 build_arch="${BUILD_ARCH}"
769 case "${HOST_ARCH},${build_arch}" in
770 x86_64,arm*|i?86,arm*|i?86,x86_64)
779 qemu_install_helper() {
780 # Do nothing, if qemu is not required
781 if ! qemu_is_required; then
785 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
786 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable.
"
789 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
790 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable.
"
794 if [ -z "${QEMU_TARGET_HELPER}" ]; then
795 exiterror "QEMU_TARGET_HELPER not
set"
798 # Check if the helper is already installed.
799 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
803 # Try to find a suitable binary that we can install
804 # to the build environment.
806 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
807 # file must exist and be executable.
808 [ -x "${file}" ] || continue
811 file_is_static "${file}" || continue
813 local dirname="${LFS}$
(dirname "${file}")"
814 mkdir -p "${dirname}"
816 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
820 exiterror "Could not
find a statically-linked QEMU emulator
: ${QEMU_TARGET_HELPER}"
823 qemu_find_build_helper_name() {
824 local build_arch="${1}"
827 case "${build_arch}" in
829 magic="7f454c4601010100000000000000000002002800
"
832 magic="7f454c4602010100000000000000000002003e00
"
836 [ -z "${magic}" ] && return 1
839 for file in /proc/sys/fs/binfmt_misc/*; do
840 # skip write only register entry
841 [ $(basename "${file}") = "register
" ] && continue
842 # Search for the file with the correct magic value.
843 grep -qE "^magic
${magic}$
" "${file}" || continue
845 local interpreter="$
(grep "^interpreter" "${file}" |
awk '{ print $2 }')"
847 [ -n "${interpreter}" ] || continue
848 [ "${interpreter:0:1}" = "/" ] || continue
849 [ -x "${interpreter}" ] || continue
851 echo "${interpreter}"
861 file ${file} 2>/dev/null | grep -q "statically linked
"
864 update_language_list() {
868 for lang in ${path}/*.po; do
869 lang="$
(basename "${lang}")"
871 done | sort -u > "${path}/LINGUAS
"
877 git shortlog --summary --numbered | while read -r commits name; do
879 done | grep -vE -e "^
(alpha197|morlix|root|ummeegge
)$
" -e "via Development$
" -e "@
" -e "#$"
882 update_contributors
() {
883 echo -n "Updating list of contributors"
885 local contributors
="$(contributors | paste -sd , - | sed -e "s
/,/&\\\\n
/g
")"
887 # Edit contributors into credits.cgi
889 "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
890 "${BASEDIR}/html/cgi-bin/credits.cgi"
896 # Load configuration file
897 if [ -f .config
]; then
901 # TARGET_ARCH is BUILD_ARCH now
902 if [ -n "${TARGET_ARCH}" ]; then
903 BUILD_ARCH
="${TARGET_ARCH}"
907 # Get the amount of memory in this build system
908 HOST_MEM
=$
(system_memory
)
910 if [ -n "${BUILD_ARCH}" ]; then
911 configure_build
"${BUILD_ARCH}"
913 configure_build
"default"
918 case "${BUILD_ARCH}:${HOST_ARCH}" in
925 i586
:i586|i586
:i686|i586
:x86_64
)
933 arvm7hl
:armv7hl|armv7hl
:armv7l
)
937 armv5tel
:armv5tel|armv5tel
:armv5tejl|armv5tel
:armv6l|armv5tel
:armv7l|armv5tel
:aarch64
)
946 exiterror
"Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
948 local gcc
=$
(type -p gcc
)
949 if [ -z "${gcc}" ]; then
950 exiterror
"Could not find GCC. You will need a working build enviroment in order to build the toolchain."
953 # Check ${TOOLS_DIR} symlink
954 if [ -h "${TOOLS_DIR}" ]; then
958 if [ ! -e "${TOOLS_DIR}" ]; then
959 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
962 if [ ! -h "${TOOLS_DIR}" ]; then
963 exiterror
"Could not create ${TOOLS_DIR} symbolic link"
966 LOGFILE
="$BASEDIR/log/_build.toolchain.log"
970 lfsmake1 ccache PASS
=1
971 lfsmake1 binutils PASS
=1
973 lfsmake1 linux KCFG
="-headers"
976 lfsmake1 binutils PASS
=2
979 lfsmake1 ccache PASS
=2
1005 lfsmake1 fake-environ
1007 lfsmake1 cleanup-toolchain
1011 LOGFILE
="$BASEDIR/log/_build.base.log"
1014 lfsmake2 linux KCFG
="-headers"
1018 lfsmake2 cleanup-toolchain
1040 lfsmake2 readline-compat
1043 lfsmake2 pcre-compat
1081 LOGFILE
="$BASEDIR/log/_build.ipfire.log"
1084 lfsmake2 initscripts
1088 lfsmake2 libusb-compat
1094 lfsmake2 linux-firmware
1095 lfsmake2 dvb-firmwares
1096 lfsmake2 xr819-firmware
1097 lfsmake2 zd1211-firmware
1098 lfsmake2 rpi-firmware
1100 lfsmake2 u-boot MKIMAGE
=1
1105 lfsmake2 multipath-tools
1111 lfsmake2 libnfnetlink
1112 lfsmake2 libnetfilter_queue
1113 lfsmake2 libnetfilter_conntrack
1114 lfsmake2 libnetfilter_cthelper
1115 lfsmake2 libnetfilter_cttimeout
1120 case "${BUILD_ARCH}" in
1122 lfsmake2 linux KCFG
=""
1123 # lfsmake2 backports KCFG=""
1124 # lfsmake2 e1000e KCFG=""
1125 # lfsmake2 igb KCFG=""
1126 # lfsmake2 ixgbe KCFG=""
1127 lfsmake2 xtables-addons KCFG
=""
1128 lfsmake2 linux-initrd KCFG
=""
1131 # x86-pae (Native and new XEN) kernel build
1132 lfsmake2 linux KCFG
="-pae"
1133 # lfsmake2 backports KCFG="-pae"
1134 # lfsmake2 e1000e KCFG="-pae"
1135 # lfsmake2 igb KCFG="-pae"
1136 # lfsmake2 ixgbe KCFG="-pae"
1137 lfsmake2 xtables-addons KCFG
="-pae"
1138 lfsmake2 linux-initrd KCFG
="-pae"
1141 lfsmake2 linux KCFG
=""
1142 # lfsmake2 backports KCFG=""
1143 # lfsmake2 e1000e KCFG=""
1144 # lfsmake2 igb KCFG=""
1145 # lfsmake2 ixgbe KCFG=""
1146 lfsmake2 xtables-addons KCFG
=""
1147 lfsmake2 linux-initrd KCFG
=""
1151 # arm-kirkwood (Dreamplug, ICY-Box ...) kernel build
1152 lfsmake2 linux KCFG
="-kirkwood"
1153 # lfsmake2 backports KCFG="-kirkwood"
1154 # lfsmake2 e1000e KCFG="-kirkwood"
1155 # lfsmake2 igb KCFG="-kirkwood"
1156 # lfsmake2 ixgbe KCFG="-kirkwood"
1157 lfsmake2 xtables-addons KCFG
="-kirkwood"
1158 lfsmake2 linux-initrd KCFG
="-kirkwood"
1160 # arm multi platform (Panda, Wandboard ...) kernel build
1161 lfsmake2 linux KCFG
="-multi"
1162 # lfsmake2 backports KCFG="-multi"
1163 # lfsmake2 e1000e KCFG="-multi"
1164 # lfsmake2 igb KCFG="-multi"
1165 # lfsmake2 ixgbe KCFG="-multi"
1166 lfsmake2 xtables-addons KCFG
="-multi"
1167 lfsmake2 linux-initrd KCFG
="-multi"
1170 lfsmake2 intel-microcode
1171 lfsmake2 xtables-addons USPACE
="1"
1173 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG
='-sse2'
1174 lfsmake2 openssl-compat
1175 lfsmake2 libgpg-error
1199 lfsmake2 ca-certificates
1207 lfsmake2 libjpeg-compat
1227 lfsmake2 web-user-interface
1237 lfsmake2 reiserfsprogs
1243 lfsmake2 ez-ipupdate
1247 lfsmake2 GD-TextUtil
1248 lfsmake2 perl-Device-SerialPort
1249 lfsmake2 perl-Device-Modem
1250 lfsmake2 perl-Apache-Htpasswd
1256 lfsmake2 conntrack-tools
1260 lfsmake2 l7-protocols
1267 lfsmake2 HTML-Tagset
1268 lfsmake2 HTML-Parser
1269 lfsmake2 HTML-Template
1270 lfsmake2 Compress-Zlib
1272 lfsmake2 Digest-SHA1
1273 lfsmake2 Digest-HMAC
1274 lfsmake2 libwww-perl
1276 lfsmake2 Net-IPv4Addr
1279 lfsmake2 IO-Socket-SSL
1280 lfsmake2 Unix-Syslog
1284 lfsmake2 Convert-TNEF
1285 lfsmake2 Convert-UUlib
1286 lfsmake2 Archive-Tar
1287 lfsmake2 Archive-Zip
1288 lfsmake2 Text-Tabs
+Wrap
1289 lfsmake2 Locale-Country
1291 lfsmake2 Crypt-PasswdMD5
1293 lfsmake2 python-setuptools
1294 lfsmake2 python-clientform
1295 lfsmake2 python-mechanize
1296 lfsmake2 python-feedparser
1297 lfsmake2 python-rssdler
1298 lfsmake2 python-inotify
1299 lfsmake2 python-docutils
1300 lfsmake2 python-daemon
1301 lfsmake2 python-ipaddress
1307 lfsmake2 dejavu-fonts-ttf
1308 lfsmake2 ubuntu-font-family
1339 lfsmake2 ghostscript
1342 lfsmake2 cups-filters
1343 lfsmake2 epson-inkjet-printer-escpr
1352 lfsmake2 bridge-utils
1353 lfsmake2 smartmontools
1358 lfsmake2 cyrus-imapd
1360 lfsmake2 spamassassin
1392 lfsmake2 pcmciautils
1401 lfsmake2 python-pyparsing
1402 lfsmake2 spice-protocol
1405 lfsmake2 libusbredir
1410 lfsmake2 nagios_nrpe
1411 lfsmake2 nagios-plugins
1418 lfsmake2 vdr_streamdev
1419 lfsmake2 vdr_epgsearch
1424 lfsmake2 icegenerator
1426 lfsmake2 libmpdclient
1428 lfsmake2 perl-Net-SMTP-SSL
1429 lfsmake2 perl-MIME-Base64
1430 lfsmake2 perl-Authen-SASL
1431 lfsmake2 perl-MIME-Lite
1432 lfsmake2 perl-Email-Date-Format
1434 lfsmake2 squidclamav
1437 lfsmake2 wpa_supplicant
1443 lfsmake2 cpufrequtils
1451 lfsmake2 streamripper
1455 lfsmake2 perl-gettext
1456 lfsmake2 perl-Sort-Naturally
1460 lfsmake2 perl-DBD-SQLite
1461 lfsmake2 perl-File-ReadBackwards
1462 lfsmake2 openvmtools
1472 lfsmake2 usb_modeswitch
1473 lfsmake2 usb_modeswitch_data
1483 lfsmake2 u-boot-kirkwood
1484 lfsmake2 python-typing
1485 lfsmake2 python-m2crypto
1486 lfsmake2 wireless-regdb
1489 lfsmake2 python-distutils-extra
1490 lfsmake2 python-lzma
1491 lfsmake2 python-progressbar
1492 lfsmake2 python-xattr
1494 lfsmake2 python3-six
1495 lfsmake2 python3-dateutil
1496 lfsmake2 python3-jmespath
1497 lfsmake2 python3-colorama
1498 lfsmake2 python3-docutils
1499 lfsmake2 python3-yaml
1500 lfsmake2 python3-s3transfer
1501 lfsmake2 python3-rsa
1502 lfsmake2 python3-pyasn1
1503 lfsmake2 python3-botocore
1505 lfsmake2 transmission
1518 lfsmake2 libstatgrab
1520 lfsmake2 check_mk_agent
1526 lfsmake2 ipfire-netboot
1532 lfsmake2 perl-Carp-Clan
1533 lfsmake2 perl-Date-Calc
1534 lfsmake2 perl-Date-Manip
1535 lfsmake2 perl-File-Tail
1536 lfsmake2 perl-TimeDate
1546 lfsmake2 perl-Font-TTF
1547 lfsmake2 perl-IO-String
1548 lfsmake2 perl-PDF-API2
1549 lfsmake2 squid-accounting
1552 lfsmake2 perl-Text-CSV_XS
1561 lfsmake2 util-macros
1562 lfsmake2 libpciaccess
1566 lfsmake2 perl-common-sense
1567 lfsmake2 perl-inotify2
1568 lfsmake2 perl-Net-IP
1571 lfsmake2 mdns-repeater
1573 lfsmake2 nss-myhostname
1577 # Run installer scripts one by one
1578 LOGFILE
="$BASEDIR/log/_build.installer.log"
1582 # use toolchain bash for chroot to strip
1583 EXTRA_PATH
=${TOOLS_DIR}/bin
/ lfsmake2 strip
1587 LOGFILE
="$BASEDIR/log/_build.packages.log"
1589 echo "... see detailed log in _build.*.log files" >> $LOGFILE
1592 # Generating list of packages used
1593 print_line
"Generating packages list from logs"
1594 rm -f $BASEDIR/doc
/packages-list
1595 for i
in `ls -1tr $BASEDIR/log/[^_]*`; do
1596 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
1597 echo "* `basename $i`" >>$BASEDIR/doc
/packages-list
1600 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc
/packages-list.txt
1601 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
1602 $BASEDIR/doc
/packages-list |
sort >> $BASEDIR/doc
/packages-list.txt
1603 rm -f $BASEDIR/doc
/packages-list
1604 # packages-list.txt is ready to be displayed for wiki page
1609 [ -z $GIT_TAG ] || LAST_TAG
=$GIT_TAG
1610 [ -z $LAST_TAG ] || EXT
="$LAST_TAG..HEAD"
1611 git log
-n 500 --no-merges --pretty=medium
--shortstat $EXT > $BASEDIR/doc
/ChangeLog
1613 # Create images for install
1616 # Check if there is a loop device for building in virtual environments
1617 modprobe loop
2>/dev
/null
1618 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev
/loop
/0 ] ||
[ -e /dev
/loop0
] ||
[ -e "/dev/loop-control" ]); then
1619 lfsmake2 flash-images
1622 mv $LFS/install
/images
/{*.iso
,*.img.xz
,*.bz2
} $BASEDIR >> $LOGFILE 2>&1
1627 mv $LFS/install
/images
/*.bz2
$BASEDIR >> $LOGFILE 2>&1
1631 # remove not useable iso on armv5tel (needed to build flash images)
1632 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
1634 for i
in `ls *.bz2 *.img.xz *.iso`; do
1641 rm -rf $BASEDIR/build
/tmp
/*
1647 lfsmake2 core-updates
1650 for i
in $
(find $BASEDIR/config
/rootfiles
/packages
{/${BUILD_ARCH},} -maxdepth 1 -type f
); do
1652 if [ -e $BASEDIR/lfs
/$i ]; then
1659 test -d $BASEDIR/packages || mkdir
$BASEDIR/packages
1660 mv -f $LFS/install
/packages
/* $BASEDIR/packages
>> $LOGFILE 2>&1
1661 rm -rf $BASEDIR/build
/install
/packages
/*
1664 while [ $# -gt 0 ]; do
1667 configure_build
"${1#--target=}"
1670 exiterror
"Unknown configuration option: ${1}"
1673 # Found a command, so exit options parsing.
1680 # See what we're supposed to do
1686 ${INTERACTIVE} && clear
1688 PACKAGE
=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
1689 #only restore on a clean disk
1690 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
1691 if [ ! -n "$PACKAGE" ]; then
1692 print_build_stage
"Full toolchain compilation"
1696 PACKAGENAME
=${PACKAGE%.tar.xz}
1697 print_build_stage
"Packaged toolchain compilation"
1698 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
1702 exiterror
"$PACKAGENAME md5 did not match, check downloaded package"
1709 print_build_stage
"Building LFS"
1712 print_build_stage
"Building IPFire"
1715 print_build_stage
"Building installer"
1718 print_build_stage
"Building packages"
1721 print_build_stage
"Checking Logfiles for new Files"
1724 tools
/checknewlog.pl
1725 tools
/checkrootfiles
1728 print_build_summary $
(( $
(now
) - ${START_TIME} ))
1731 # enter a shell inside LFS chroot
1732 # may be used to changed kernel settings
1737 print_line
"Cleaning build directory..."
1739 for i
in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1740 $LOSETUP -d $i 2>/dev
/null
1742 for i
in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1746 for i
in `seq 0 7`; do
1747 if ( losetup
/dev
/loop
${i} 2>/dev
/null |
grep -q "/install/images" ); then
1748 umount
/dev
/loop
${i} 2>/dev
/null
;
1749 losetup
-d /dev
/loop
${i} 2>/dev
/null
;
1752 rm -rf $BASEDIR/build
1753 rm -rf $BASEDIR/cdrom
1754 rm -rf $BASEDIR/packages
1756 if [ -h "${TOOLS_DIR}" ]; then
1757 rm -f "${TOOLS_DIR}"
1759 rm -f $BASEDIR/ipfire-
*
1763 if [ ! -d $BASEDIR/cache
]; then
1764 mkdir
$BASEDIR/cache
1766 mkdir
-p $BASEDIR/log
1767 echo -e "${BOLD}Preload all source files${NORMAL}" |
tee -a $LOGFILE
1770 for c
in `seq $MAX_RETRIES`; do
1771 if (( FINISHED
==1 )); then
1777 if [ -f "$i" -a "$i" != "Config" ]; then
1778 lfsmakecommoncheck
${i} ||
continue
1780 make -s -f $i LFS_BASEDIR
=$BASEDIR BUILD_ARCH
="${BUILD_ARCH}" \
1781 MESSAGE
="$i\t ($c/$MAX_RETRIES)" download
>> $LOGFILE 2>&1
1782 if [ $?
-ne 0 ]; then
1786 if [ $c -eq 1 ]; then
1793 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
1796 if [ -f "$i" -a "$i" != "Config" ]; then
1797 lfsmakecommoncheck
${i} > /dev
/null ||
continue
1798 make -s -f $i LFS_BASEDIR
=$BASEDIR BUILD_ARCH
="${BUILD_ARCH}" \
1799 MESSAGE
="$i\t " md5
>> $LOGFILE 2>&1
1800 if [ $?
-ne 0 ]; then
1801 echo -ne "MD5 difference in lfs/$i"
1807 if [ $ERROR -eq 0 ]; then
1808 echo -ne "${BOLD}all files md5sum match${NORMAL}"
1811 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
1814 cd - >/dev
/null
2>&1
1818 ${INTERACTIVE} && clear
1821 print_build_stage
"Toolchain compilation (${BUILD_ARCH})"
1823 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" |
tee -a $LOGFILE
1824 test -d $BASEDIR/cache
/toolchains || mkdir
-p $BASEDIR/cache
/toolchains
1825 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build
/${TOOLS_DIR} build
/bin
/sh log | xz
${XZ_OPT} \
1826 > cache
/toolchains
/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.
tar.xz
1827 md5sum cache
/toolchains
/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.
tar.xz \
1828 > cache
/toolchains
/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
1832 # arbitrary name to be updated in case of new toolchain package upload
1833 PACKAGE
=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
1834 if [ ! -f $BASEDIR/cache
/toolchains
/$PACKAGE.
tar.xz
]; then
1835 URL_TOOLCHAIN
=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
1836 test -d $BASEDIR/cache
/toolchains || mkdir
-p $BASEDIR/cache
/toolchains
1837 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" |
tee -a $LOGFILE
1838 cd $BASEDIR/cache
/toolchains
1839 wget
-U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.
tar.xz
$URL_TOOLCHAIN/$PACKAGE.md5
>& /dev
/null
1840 if [ $?
-ne 0 ]; then
1841 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" |
tee -a $LOGFILE
1843 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
1844 echo "`date -u '+%b %e %T'`: toolchain md5 ok" |
tee -a $LOGFILE
1846 exiterror
"$PACKAGE.md5 did not match, check downloaded package"
1850 echo "Toolchain is already downloaded. Exiting..."
1855 if [ -z $IPFIRE_USER ]; then
1856 echo -n "You have to setup IPFIRE_USER first. See .config for details."
1861 URL_SOURCE
=$
(grep URL_SOURCE lfs
/Config |
awk '{ print $3 }')
1862 REMOTE_FILES
=$
(echo "ls -1" | sftp
-C ${IPFIRE_USER}@
${URL_SOURCE})
1864 for file in ${BASEDIR}/cache
/*; do
1865 [ -d "${file}" ] && continue
1866 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
1867 NEW_FILES
="$NEW_FILES $file"
1869 [ -n "$NEW_FILES" ] && scp
-2 $NEW_FILES ${IPFIRE_USER}@
${URL_SOURCE}
1875 echo -ne "Checking the translations for missing or obsolete strings..."
1876 chmod 755 $BASEDIR/tools
/{check_strings.pl
,sort_strings.pl
,check_langs.sh
}
1877 $BASEDIR/tools
/sort_strings.pl en
1878 $BASEDIR/tools
/sort_strings.pl de
1879 $BASEDIR/tools
/sort_strings.pl fr
1880 $BASEDIR/tools
/sort_strings.pl es
1881 $BASEDIR/tools
/sort_strings.pl pl
1882 $BASEDIR/tools
/sort_strings.pl ru
1883 $BASEDIR/tools
/sort_strings.pl
nl
1884 $BASEDIR/tools
/sort_strings.pl
tr
1885 $BASEDIR/tools
/sort_strings.pl it
1886 $BASEDIR/tools
/check_strings.pl en
> $BASEDIR/doc
/language_issues.en
1887 $BASEDIR/tools
/check_strings.pl de
> $BASEDIR/doc
/language_issues.de
1888 $BASEDIR/tools
/check_strings.pl fr
> $BASEDIR/doc
/language_issues.fr
1889 $BASEDIR/tools
/check_strings.pl es
> $BASEDIR/doc
/language_issues.es
1890 $BASEDIR/tools
/check_strings.pl es
> $BASEDIR/doc
/language_issues.pl
1891 $BASEDIR/tools
/check_strings.pl ru
> $BASEDIR/doc
/language_issues.ru
1892 $BASEDIR/tools
/check_strings.pl
nl > $BASEDIR/doc
/language_issues.
nl
1893 $BASEDIR/tools
/check_strings.pl
tr > $BASEDIR/doc
/language_issues.
tr
1894 $BASEDIR/tools
/check_strings.pl it
> $BASEDIR/doc
/language_issues.it
1895 $BASEDIR/tools
/check_langs.sh
> $BASEDIR/doc
/language_missings
1898 echo -ne "Updating language lists..."
1899 update_language_list
${BASEDIR}/src
/installer
/po
1900 update_language_list
${BASEDIR}/src
/setup
/po
1903 update-contributors
)
1907 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors}"
1908 cat doc
/make.sh-usage